2017/04/21  
2023/08/04改訂

# MyDNS.JPのサーバに現在のIPアドレスを通知するスクリプト

## バージョン

2017/04/21 version 3.2.0  
2023/08/04 version 3.3.0

* `base64`モジュールの`encodestring()`メソッドが廃止され、`b64encode()`になったことにともない修正した。

## 環境設定

スクリプト内の以下の変数を環境に合わせて変更してください。

| 変数名              | 設定内容                                                         |
|---------------------|------------------------------------------------------------------|
| `MYDNS_URL`         | MyDNS.JPのIPアドレス通知用URL(通常はこのままで良いはず)          |
| `USER`              | MyDNS.JPのマスターID                                             |
| `PASSWD`            | MyDNS.JPのパスワード                                             |
| `TARGET_DOMAIN`     | 対象となるドメイン                                               |
| `IP_CHECK_URL`      | 現在のIPアドレスを取得するためのURL                              |
| `IP_CHECK_INTERVAL` | IPアドレスに変化がないかチェックする間隔(分単位)                 |
| `DEFAULT_INTERVAL`  | IPアドレスに変化があろうがなかろうが定期的に通知する間隔(分単位) |
| `LOG_LEVEL`         | ログレベル(※注)                                                 |
| `LOG_FILE_NAME`     | ログファイルのファイル名                                         |

### ※注

* `0`: なし: 全てのログを記録しない
* `1`: 通知: 「IPアドレスに変化があった時」「定期通知」「エラー」
* `2`: 全て: `1`に加え「IPアドレスに変化がなかった時」も含む

## 実行方法

* 環境設定で、「ログレベル」を`1`または`2`にした場合は、「ログファイルのファイル名」を
  必ず指定してください。サーバ等で実行する場合は、絶対パスで記述するのをおすすめします。
* このスクリプトに実行権限を付与すればそのまま実行できます。
  + `$ ./mydns.py`
* 実行権限を付与しない場合は、`python3`で実行してください。
  + `$ python3 mydns.py`
* デフォルトでは、標準出力に何も出力しません。
* `-v`オプションで、標準出力にメッセージを出力します。出力されるメッセージは、
  ログレベルを`2` (全て)にした相当です。端末での評価等で利用すると良いでしょう。
* ログファイルのオープンや書き込みに失敗した場合は、`-v`の有無にかかわらず、
  標準出力にエラーを表示します。
* `-h`オプションが含まれているとUsageを表示します。
* `-v`オプションと`-h`が同時に指定されても`-h`が優先されます。

以上